/*!
  * vue-i18n-bridge v9.14.1
  * (c) 2024 kazuya kawaguchi
  * Released under the MIT License.
  */
import{computed,watch,getCurrentInstance,ref,shallowRef,defineComponent,h,effectScope,onBeforeMount,onUnmounted}from"vue-demi";const inBrowser="undefined"!=typeof window,makeSymbol=(e,t=!1)=>t?Symbol.for(e):Symbol(e),generateFormatCacheKey=(e,t,n)=>friendlyJSONstringify({l:e,k:t,s:n}),friendlyJSONstringify=e=>JSON.stringify(e).replace(/\u2028/g,"\\u2028").replace(/\u2029/g,"\\u2029").replace(/\u0027/g,"\\u0027"),isNumber=e=>"number"==typeof e&&isFinite(e),isDate=e=>"[object Date]"===toTypeString(e),isRegExp=e=>"[object RegExp]"===toTypeString(e),isEmptyObject=e=>isPlainObject(e)&&0===Object.keys(e).length,assign=Object.assign;function escapeHtml(e){return e.replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/"/g,"&quot;").replace(/'/g,"&apos;")}const hasOwnProperty=Object.prototype.hasOwnProperty;function hasOwn(e,t){return hasOwnProperty.call(e,t)}const isArray=Array.isArray,isFunction=e=>"function"==typeof e,isString=e=>"string"==typeof e,isBoolean=e=>"boolean"==typeof e,isObject=e=>null!==e&&"object"==typeof e,isPromise=e=>isObject(e)&&isFunction(e.then)&&isFunction(e.catch),objectToString=Object.prototype.toString,toTypeString=e=>objectToString.call(e),isPlainObject=e=>{if(!isObject(e))return!1;const t=Object.getPrototypeOf(e);return null===t||t.constructor===Object},toDisplayString=e=>null==e?"":isArray(e)||isPlainObject(e)&&e.toString===objectToString?JSON.stringify(e,null,2):String(e);function join(e,t=""){return e.reduce(((e,n,r)=>0===r?e+n:e+t+n),"")}function incrementer(e){let t=e;return()=>++t}function warn(e,t){"undefined"!=typeof console&&(console.warn("[intlify] "+e),t&&console.warn(t.stack))}const isNotObjectOrIsArray=e=>!isObject(e)||isArray(e);function deepCopy(e,t){if(isNotObjectOrIsArray(e)||isNotObjectOrIsArray(t))throw new Error("Invalid value");const n=[{src:e,des:t}];for(;n.length;){const{src:e,des:t}=n.pop();Object.keys(e).forEach((r=>{isObject(e[r])&&!isObject(t[r])&&(t[r]=Array.isArray(e[r])?[]:{}),isNotObjectOrIsArray(t[r])||isNotObjectOrIsArray(e[r])?t[r]=e[r]:n.push({src:e[r],des:t[r]})}))}}function createPosition(e,t,n){return{line:e,column:t,offset:n}}function createLocation(e,t,n){const r={start:e,end:t};return null!=n&&(r.source=n),r}const CompileWarnCodes={USE_MODULO_SYNTAX:1,__EXTEND_POINT__:2};function createCompileWarn(e,t,...n){const r={message:String(e),code:e};return t&&(r.location=t),r}const CompileErrorCodes={EXPECTED_TOKEN:1,INVALID_TOKEN_IN_PLACEHOLDER:2,UNTERMINATED_SINGLE_QUOTE_IN_PLACEHOLDER:3,UNKNOWN_ESCAPE_SEQUENCE:4,INVALID_UNICODE_ESCAPE_SEQUENCE:5,UNBALANCED_CLOSING_BRACE:6,UNTERMINATED_CLOSING_BRACE:7,EMPTY_PLACEHOLDER:8,NOT_ALLOW_NEST_PLACEHOLDER:9,INVALID_LINKED_FORMAT:10,MUST_HAVE_MESSAGES_IN_PLURAL:11,UNEXPECTED_EMPTY_LINKED_MODIFIER:12,UNEXPECTED_EMPTY_LINKED_KEY:13,UNEXPECTED_LEXICAL_ANALYSIS:14,UNHANDLED_CODEGEN_NODE_TYPE:15,UNHANDLED_MINIFIER_NODE_TYPE:16,__EXTEND_POINT__:17};function createCompileError(e,t,n={}){const{domain:r,messages:a,args:o}=n,s=new SyntaxError(String(e));return s.code=e,t&&(s.location=t),s.domain=r,s}function defaultOnError(e){throw e}const CHAR_SP=" ",CHAR_CR="\r",CHAR_LF="\n",CHAR_LS=String.fromCharCode(8232),CHAR_PS=String.fromCharCode(8233);function createScanner(e){const t=e;let n=0,r=1,a=1,o=0;const s=e=>t[e]===CHAR_CR&&t[e+1]===CHAR_LF,i=e=>t[e]===CHAR_PS,l=e=>t[e]===CHAR_LS,c=e=>s(e)||(e=>t[e]===CHAR_LF)(e)||i(e)||l(e),u=e=>s(e)||i(e)||l(e)?CHAR_LF:t[e];function m(){return o=0,c(n)&&(r++,a=0),s(n)&&n++,n++,a++,t[n]}return{index:()=>n,line:()=>r,column:()=>a,peekOffset:()=>o,charAt:u,currentChar:()=>u(n),currentPeek:()=>u(n+o),next:m,peek:function(){return s(n+o)&&o++,o++,t[n+o]},reset:function(){n=0,r=1,a=1,o=0},resetPeek:function(e=0){o=e},skipToPeek:function(){const e=n+o;for(;e!==n;)m();o=0}}}const EOF=void 0,DOT=".",LITERAL_DELIMITER="'",ERROR_DOMAIN$1="tokenizer";function createTokenizer(e,t={}){const n=!1!==t.location,r=createScanner(e),a=()=>r.index(),o=()=>createPosition(r.line(),r.column(),r.index()),s=o(),i=a(),l={currentType:14,offset:i,startLoc:s,endLoc:s,lastType:14,lastOffset:i,lastStartLoc:s,lastEndLoc:s,braceNest:0,inLinked:!1,text:""},c=()=>l,{onError:u}=t;function m(e,t,r){e.endLoc=o(),e.currentType=t;const a={type:t};return n&&(a.loc=createLocation(e.startLoc,e.endLoc)),null!=r&&(a.value=r),a}const f=e=>m(e,14);function p(e,t){return e.currentChar()===t?(e.next(),t):(CompileErrorCodes.EXPECTED_TOKEN,o(),"")}function _(e){let t="";for(;e.currentPeek()===CHAR_SP||e.currentPeek()===CHAR_LF;)t+=e.currentPeek(),e.peek();return t}function g(e){const t=_(e);return e.skipToPeek(),t}function d(e){if(e===EOF)return!1;const t=e.charCodeAt(0);return t>=97&&t<=122||t>=65&&t<=90||95===t}function E(e,t){const{currentType:n}=t;if(2!==n)return!1;_(e);const r=function(e){if(e===EOF)return!1;const t=e.charCodeAt(0);return t>=48&&t<=57}("-"===e.currentPeek()?e.peek():e.currentPeek());return e.resetPeek(),r}function b(e){_(e);const t="|"===e.currentPeek();return e.resetPeek(),t}function C(e,t=!0){const n=(t=!1,r="",a=!1)=>{const o=e.currentPeek();return"{"===o?"%"!==r&&t:"@"!==o&&o?"%"===o?(e.peek(),n(t,"%",!0)):"|"===o?!("%"!==r&&!a)||!(r===CHAR_SP||r===CHAR_LF):o===CHAR_SP?(e.peek(),n(!0,CHAR_SP,a)):o!==CHAR_LF||(e.peek(),n(!0,CHAR_LF,a)):"%"===r||t},r=n();return t&&e.resetPeek(),r}function N(e,t){const n=e.currentChar();return n===EOF?EOF:t(n)?(e.next(),n):null}function L(e){const t=e.charCodeAt(0);return t>=97&&t<=122||t>=65&&t<=90||t>=48&&t<=57||95===t||36===t}function O(e){return N(e,L)}function h(e){const t=e.charCodeAt(0);return t>=97&&t<=122||t>=65&&t<=90||t>=48&&t<=57||95===t||36===t||45===t}function T(e){return N(e,h)}function v(e){const t=e.charCodeAt(0);return t>=48&&t<=57}function y(e){return N(e,v)}function S(e){const t=e.charCodeAt(0);return t>=48&&t<=57||t>=65&&t<=70||t>=97&&t<=102}function k(e){return N(e,S)}function I(e){let t="",n="";for(;t=y(e);)n+=t;return n}function A(e){let t="";for(;;){const n=e.currentChar();if("{"===n||"}"===n||"@"===n||"|"===n||!n)break;if("%"===n){if(!C(e))break;t+=n,e.next()}else if(n===CHAR_SP||n===CHAR_LF)if(C(e))t+=n,e.next();else{if(b(e))break;t+=n,e.next()}else t+=n,e.next()}return t}function P(e){return e!==LITERAL_DELIMITER&&e!==CHAR_LF}function F(e){const t=e.currentChar();switch(t){case"\\":case"'":return e.next(),`\\${t}`;case"u":return R(e,t,4);case"U":return R(e,t,6);default:return CompileErrorCodes.UNKNOWN_ESCAPE_SEQUENCE,o(),""}}function R(e,t,n){p(e,t);let r="";for(let a=0;a<n;a++){const t=k(e);if(!t){CompileErrorCodes.INVALID_UNICODE_ESCAPE_SEQUENCE,o(),e.currentChar();break}r+=t}return`\\${t}${r}`}function M(e){return"{"!==e&&"}"!==e&&e!==CHAR_SP&&e!==CHAR_LF}function D(e){g(e);const t=p(e,"|");return g(e),t}function j(e,t){let n=null;switch(e.currentChar()){case"{":return t.braceNest>=1&&(CompileErrorCodes.NOT_ALLOW_NEST_PLACEHOLDER,o()),e.next(),n=m(t,2,"{"),g(e),t.braceNest++,n;case"}":return t.braceNest>0&&2===t.currentType&&(CompileErrorCodes.EMPTY_PLACEHOLDER,o()),e.next(),n=m(t,3,"}"),t.braceNest--,t.braceNest>0&&g(e),t.inLinked&&0===t.braceNest&&(t.inLinked=!1),n;case"@":return t.braceNest>0&&(CompileErrorCodes.UNTERMINATED_CLOSING_BRACE,o()),n=U(e,t)||f(t),t.braceNest=0,n;default:{let r=!0,a=!0,s=!0;if(b(e))return t.braceNest>0&&(CompileErrorCodes.UNTERMINATED_CLOSING_BRACE,o()),n=m(t,1,D(e)),t.braceNest=0,t.inLinked=!1,n;if(t.braceNest>0&&(5===t.currentType||6===t.currentType||7===t.currentType))return CompileErrorCodes.UNTERMINATED_CLOSING_BRACE,o(),t.braceNest=0,w(e,t);if(r=function(e,t){const{currentType:n}=t;if(2!==n)return!1;_(e);const r=d(e.currentPeek());return e.resetPeek(),r}(e,t))return n=m(t,5,function(e){g(e);let t="",n="";for(;t=T(e);)n+=t;return e.currentChar()===EOF&&(CompileErrorCodes.UNTERMINATED_CLOSING_BRACE,o()),n}(e)),g(e),n;if(a=E(e,t))return n=m(t,6,function(e){g(e);let t="";return"-"===e.currentChar()?(e.next(),t+=`-${I(e)}`):t+=I(e),e.currentChar()===EOF&&(CompileErrorCodes.UNTERMINATED_CLOSING_BRACE,o()),t}(e)),g(e),n;if(s=function(e,t){const{currentType:n}=t;if(2!==n)return!1;_(e);const r=e.currentPeek()===LITERAL_DELIMITER;return e.resetPeek(),r}(e,t))return n=m(t,7,function(e){g(e),p(e,"'");let t="",n="";for(;t=N(e,P);)n+="\\"===t?F(e):t;const r=e.currentChar();return r===CHAR_LF||r===EOF?(CompileErrorCodes.UNTERMINATED_SINGLE_QUOTE_IN_PLACEHOLDER,o(),r===CHAR_LF&&(e.next(),p(e,"'")),n):(p(e,"'"),n)}(e)),g(e),n;if(!r&&!a&&!s)return n=m(t,13,function(e){g(e);let t="",n="";for(;t=N(e,M);)n+=t;return n}(e)),CompileErrorCodes.INVALID_TOKEN_IN_PLACEHOLDER,o(),n.value,g(e),n;break}}return n}function U(e,t){const{currentType:n}=t;let r=null;const a=e.currentChar();switch(8!==n&&9!==n&&12!==n&&10!==n||a!==CHAR_LF&&a!==CHAR_SP||(CompileErrorCodes.INVALID_LINKED_FORMAT,o()),a){case"@":return e.next(),r=m(t,8,"@"),t.inLinked=!0,r;case".":return g(e),e.next(),m(t,9,".");case":":return g(e),e.next(),m(t,10,":");default:return b(e)?(r=m(t,1,D(e)),t.braceNest=0,t.inLinked=!1,r):function(e,t){const{currentType:n}=t;if(8!==n)return!1;_(e);const r="."===e.currentPeek();return e.resetPeek(),r}(e,t)||function(e,t){const{currentType:n}=t;if(8!==n&&12!==n)return!1;_(e);const r=":"===e.currentPeek();return e.resetPeek(),r}(e,t)?(g(e),U(e,t)):function(e,t){const{currentType:n}=t;if(9!==n)return!1;_(e);const r=d(e.currentPeek());return e.resetPeek(),r}(e,t)?(g(e),m(t,12,function(e){let t="",n="";for(;t=O(e);)n+=t;return n}(e))):function(e,t){const{currentType:n}=t;if(10!==n)return!1;const r=()=>{const t=e.currentPeek();return"{"===t?d(e.peek()):!("@"===t||"%"===t||"|"===t||":"===t||"."===t||t===CHAR_SP||!t)&&(t===CHAR_LF?(e.peek(),r()):C(e,!1))},a=r();return e.resetPeek(),a}(e,t)?(g(e),"{"===a?j(e,t)||r:m(t,11,function(e){const t=n=>{const r=e.currentChar();return"{"!==r&&"%"!==r&&"@"!==r&&"|"!==r&&"("!==r&&")"!==r&&r?r===CHAR_SP?n:(n+=r,e.next(),t(n)):n};return t("")}(e))):(8===n&&(CompileErrorCodes.INVALID_LINKED_FORMAT,o()),t.braceNest=0,t.inLinked=!1,w(e,t))}}function w(e,t){let n={type:14};if(t.braceNest>0)return j(e,t)||f(t);if(t.inLinked)return U(e,t)||f(t);switch(e.currentChar()){case"{":return j(e,t)||f(t);case"}":return CompileErrorCodes.UNBALANCED_CLOSING_BRACE,o(),e.next(),m(t,3,"}");case"@":return U(e,t)||f(t);default:{if(b(e))return n=m(t,1,D(e)),t.braceNest=0,t.inLinked=!1,n;const{isModulo:r,hasSpace:a}=function(e){const t=_(e),n="%"===e.currentPeek()&&"{"===e.peek();return e.resetPeek(),{isModulo:n,hasSpace:t.length>0}}(e);if(r)return a?m(t,0,A(e)):m(t,4,function(e){g(e);const t=e.currentChar();return"%"!==t&&(CompileErrorCodes.EXPECTED_TOKEN,o()),e.next(),"%"}(e));if(C(e))return m(t,0,A(e));break}}return n}return{nextToken:function(){const{currentType:e,offset:t,startLoc:n,endLoc:s}=l;return l.lastType=e,l.lastOffset=t,l.lastStartLoc=n,l.lastEndLoc=s,l.offset=a(),l.startLoc=o(),r.currentChar()===EOF?m(l,14):w(r,l)},currentOffset:a,currentPosition:o,context:c}}const ERROR_DOMAIN="parser",KNOWN_ESCAPES=/(?:\\\\|\\'|\\u([0-9a-fA-F]{4})|\\U([0-9a-fA-F]{6}))/g;function fromEscapeSequence(e,t,n){switch(e){case"\\\\":return"\\";case"\\'":return"'";default:{const e=parseInt(t||n,16);return e<=55295||e>=57344?String.fromCodePoint(e):"�"}}}function createParser(e={}){const t=!1!==e.location,{onError:n,onWarn:r}=e;function a(e,n,r){const a={type:e};return t&&(a.start=n,a.end=n,a.loc={start:r,end:r}),a}function o(e,n,r,a){a&&(e.type=a),t&&(e.end=n,e.loc&&(e.loc.end=r))}function s(e,t){const n=e.context(),r=a(3,n.offset,n.startLoc);return r.value=t,o(r,e.currentOffset(),e.currentPosition()),r}function i(e,t){const n=e.context(),{lastOffset:r,lastStartLoc:s}=n,i=a(5,r,s);return i.index=parseInt(t,10),e.nextToken(),o(i,e.currentOffset(),e.currentPosition()),i}function l(e,t,n){const r=e.context(),{lastOffset:s,lastStartLoc:i}=r,l=a(4,s,i);return l.key=t,!0===n&&(l.modulo=!0),e.nextToken(),o(l,e.currentOffset(),e.currentPosition()),l}function c(e,t){const n=e.context(),{lastOffset:r,lastStartLoc:s}=n,i=a(9,r,s);return i.value=t.replace(KNOWN_ESCAPES,fromEscapeSequence),e.nextToken(),o(i,e.currentOffset(),e.currentPosition()),i}function u(e){const t=e.context(),n=a(6,t.offset,t.startLoc);let r=e.nextToken();if(9===r.type){const t=function(e){const t=e.nextToken(),n=e.context(),{lastOffset:r,lastStartLoc:s}=n,i=a(8,r,s);return 12!==t.type?(CompileErrorCodes.UNEXPECTED_EMPTY_LINKED_MODIFIER,n.lastStartLoc,i.value="",o(i,r,s),{nextConsumeToken:t,node:i}):(null==t.value&&(CompileErrorCodes.UNEXPECTED_LEXICAL_ANALYSIS,n.lastStartLoc,getTokenCaption(t)),i.value=t.value||"",o(i,e.currentOffset(),e.currentPosition()),{node:i})}(e);n.modifier=t.node,r=t.nextConsumeToken||e.nextToken()}switch(10!==r.type&&(CompileErrorCodes.UNEXPECTED_LEXICAL_ANALYSIS,t.lastStartLoc,getTokenCaption(r)),r=e.nextToken(),2===r.type&&(r=e.nextToken()),r.type){case 11:null==r.value&&(CompileErrorCodes.UNEXPECTED_LEXICAL_ANALYSIS,t.lastStartLoc,getTokenCaption(r)),n.key=function(e,t){const n=e.context(),r=a(7,n.offset,n.startLoc);return r.value=t,o(r,e.currentOffset(),e.currentPosition()),r}(e,r.value||"");break;case 5:null==r.value&&(CompileErrorCodes.UNEXPECTED_LEXICAL_ANALYSIS,t.lastStartLoc,getTokenCaption(r)),n.key=l(e,r.value||"");break;case 6:null==r.value&&(CompileErrorCodes.UNEXPECTED_LEXICAL_ANALYSIS,t.lastStartLoc,getTokenCaption(r)),n.key=i(e,r.value||"");break;case 7:null==r.value&&(CompileErrorCodes.UNEXPECTED_LEXICAL_ANALYSIS,t.lastStartLoc,getTokenCaption(r)),n.key=c(e,r.value||"");break;default:{CompileErrorCodes.UNEXPECTED_EMPTY_LINKED_KEY,t.lastStartLoc;const s=e.context(),i=a(7,s.offset,s.startLoc);return i.value="",o(i,s.offset,s.startLoc),n.key=i,o(n,s.offset,s.startLoc),{nextConsumeToken:r,node:n}}}return o(n,e.currentOffset(),e.currentPosition()),{node:n}}function m(e){const t=e.context(),n=a(2,1===t.currentType?e.currentOffset():t.offset,1===t.currentType?t.endLoc:t.startLoc);n.items=[];let r=null,m=null;do{const a=r||e.nextToken();switch(r=null,a.type){case 0:null==a.value&&(CompileErrorCodes.UNEXPECTED_LEXICAL_ANALYSIS,t.lastStartLoc,getTokenCaption(a)),n.items.push(s(e,a.value||""));break;case 6:null==a.value&&(CompileErrorCodes.UNEXPECTED_LEXICAL_ANALYSIS,t.lastStartLoc,getTokenCaption(a)),n.items.push(i(e,a.value||""));break;case 4:m=!0;break;case 5:null==a.value&&(CompileErrorCodes.UNEXPECTED_LEXICAL_ANALYSIS,t.lastStartLoc,getTokenCaption(a)),n.items.push(l(e,a.value||"",!!m)),m&&(CompileWarnCodes.USE_MODULO_SYNTAX,t.lastStartLoc,getTokenCaption(a),m=null);break;case 7:null==a.value&&(CompileErrorCodes.UNEXPECTED_LEXICAL_ANALYSIS,t.lastStartLoc,getTokenCaption(a)),n.items.push(c(e,a.value||""));break;case 8:{const t=u(e);n.items.push(t.node),r=t.nextConsumeToken||null;break}}}while(14!==t.currentType&&1!==t.currentType);return o(n,1===t.currentType?t.lastOffset:e.currentOffset(),1===t.currentType?t.lastEndLoc:e.currentPosition()),n}function f(e){const t=e.context(),{offset:n,startLoc:r}=t,s=m(e);return 14===t.currentType?s:function(e,t,n,r){const s=e.context();let i=0===r.items.length;const l=a(1,t,n);l.cases=[],l.cases.push(r);do{const t=m(e);i||(i=0===t.items.length),l.cases.push(t)}while(14!==s.currentType);return o(l,e.currentOffset(),e.currentPosition()),l}(e,n,r,s)}return{parse:function(n){const r=createTokenizer(n,assign({},e)),s=r.context(),i=a(0,s.offset,s.startLoc);return t&&i.loc&&(i.loc.source=n),i.body=f(r),e.onCacheKey&&(i.cacheKey=e.onCacheKey(n)),14!==s.currentType&&(CompileErrorCodes.UNEXPECTED_LEXICAL_ANALYSIS,s.lastStartLoc,n[s.offset]),o(i,r.currentOffset(),r.currentPosition()),i}}}function getTokenCaption(e){if(14===e.type)return"EOF";const t=(e.value||"").replace(/\r?\n/gu,"\\n");return t.length>10?t.slice(0,9)+"…":t}function createTransformer(e,t={}){const n={ast:e,helpers:new Set};return{context:()=>n,helper:e=>(n.helpers.add(e),e)}}function traverseNodes(e,t){for(let n=0;n<e.length;n++)traverseNode(e[n],t)}function traverseNode(e,t){switch(e.type){case 1:traverseNodes(e.cases,t),t.helper("plural");break;case 2:traverseNodes(e.items,t);break;case 6:traverseNode(e.key,t),t.helper("linked"),t.helper("type");break;case 5:t.helper("interpolate"),t.helper("list");break;case 4:t.helper("interpolate"),t.helper("named")}}function transform(e,t={}){const n=createTransformer(e);n.helper("normalize"),e.body&&traverseNode(e.body,n);const r=n.context();e.helpers=Array.from(r.helpers)}function optimize(e){const t=e.body;return 2===t.type?optimizeMessageNode(t):t.cases.forEach((e=>optimizeMessageNode(e))),e}function optimizeMessageNode(e){if(1===e.items.length){const t=e.items[0];3!==t.type&&9!==t.type||(e.static=t.value,delete t.value)}else{const t=[];for(let n=0;n<e.items.length;n++){const r=e.items[n];if(3!==r.type&&9!==r.type)break;if(null==r.value)break;t.push(r.value)}if(t.length===e.items.length){e.static=join(t);for(let t=0;t<e.items.length;t++){const n=e.items[t];3!==n.type&&9!==n.type||delete n.value}}}}function minify(e){switch(e.t=e.type,e.type){case 0:{const t=e;minify(t.body),t.b=t.body,delete t.body;break}case 1:{const t=e,n=t.cases;for(let e=0;e<n.length;e++)minify(n[e]);t.c=n,delete t.cases;break}case 2:{const t=e,n=t.items;for(let e=0;e<n.length;e++)minify(n[e]);t.i=n,delete t.items,t.static&&(t.s=t.static,delete t.static);break}case 3:case 9:case 8:case 7:{const t=e;t.value&&(t.v=t.value,delete t.value);break}case 6:{const t=e;minify(t.key),t.k=t.key,delete t.key,t.modifier&&(minify(t.modifier),t.m=t.modifier,delete t.modifier);break}case 5:{const t=e;t.i=t.index,delete t.index;break}case 4:{const t=e;t.k=t.key,delete t.key;break}}delete e.type}function createCodeGenerator(e,t){const{sourceMap:n,filename:r,breakLineCode:a,needIndent:o}=t,s=!1!==t.location,i={filename:r,code:"",column:1,line:1,offset:0,map:void 0,breakLineCode:a,needIndent:o,indentLevel:0};s&&e.loc&&(i.source=e.loc.source);function l(e,t){i.code+=e}function c(e,t=!0){const n=t?a:"";l(o?n+"  ".repeat(e):n)}return{context:()=>i,push:l,indent:function(e=!0){const t=++i.indentLevel;e&&c(t)},deindent:function(e=!0){const t=--i.indentLevel;e&&c(t)},newline:function(){c(i.indentLevel)},helper:e=>`_${e}`,needIndent:()=>i.needIndent}}function generateLinkedNode(e,t){const{helper:n}=e;e.push(`${n("linked")}(`),generateNode(e,t.key),t.modifier?(e.push(", "),generateNode(e,t.modifier),e.push(", _type")):e.push(", undefined, _type"),e.push(")")}function generateMessageNode(e,t){const{helper:n,needIndent:r}=e;e.push(`${n("normalize")}([`),e.indent(r());const a=t.items.length;for(let o=0;o<a&&(generateNode(e,t.items[o]),o!==a-1);o++)e.push(", ");e.deindent(r()),e.push("])")}function generatePluralNode(e,t){const{helper:n,needIndent:r}=e;if(t.cases.length>1){e.push(`${n("plural")}([`),e.indent(r());const a=t.cases.length;for(let n=0;n<a&&(generateNode(e,t.cases[n]),n!==a-1);n++)e.push(", ");e.deindent(r()),e.push("])")}}function generateResource(e,t){t.body?generateNode(e,t.body):e.push("null")}function generateNode(e,t){const{helper:n}=e;switch(t.type){case 0:generateResource(e,t);break;case 1:generatePluralNode(e,t);break;case 2:generateMessageNode(e,t);break;case 6:generateLinkedNode(e,t);break;case 8:case 7:case 9:case 3:e.push(JSON.stringify(t.value),t);break;case 5:e.push(`${n("interpolate")}(${n("list")}(${t.index}))`,t);break;case 4:e.push(`${n("interpolate")}(${n("named")}(${JSON.stringify(t.key)}))`,t)}}const generate=(e,t={})=>{const n=isString(t.mode)?t.mode:"normal",r=isString(t.filename)?t.filename:"message.intl",a=!!t.sourceMap,o=null!=t.breakLineCode?t.breakLineCode:"arrow"===n?";":"\n",s=t.needIndent?t.needIndent:"arrow"!==n,i=e.helpers||[],l=createCodeGenerator(e,{mode:n,filename:r,sourceMap:a,breakLineCode:o,needIndent:s});l.push("normal"===n?"function __msg__ (ctx) {":"(ctx) => {"),l.indent(s),i.length>0&&(l.push(`const { ${join(i.map((e=>`${e}: _${e}`)),", ")} } = ctx`),l.newline()),l.push("return "),generateNode(l,e),l.deindent(s),l.push("}"),delete e.helpers;const{code:c,map:u}=l.context();return{ast:e,code:c,map:u?u.toJSON():void 0}};function baseCompile$1(e,t={}){const n=assign({},t),r=!!n.jit,a=!!n.minify,o=null==n.optimize||n.optimize,s=createParser(n).parse(e);return r?(o&&optimize(s),a&&minify(s),{ast:s,code:""}):(transform(s,n),generate(s,n))}const pathStateMachine=[];pathStateMachine[0]={w:[0],i:[3,0],"[":[4],o:[7]},pathStateMachine[1]={w:[1],".":[2],"[":[4],o:[7]},pathStateMachine[2]={w:[2],i:[3,0],0:[3,0]},pathStateMachine[3]={i:[3,0],0:[3,0],w:[1,1],".":[2,1],"[":[4,1],o:[7,1]},pathStateMachine[4]={"'":[5,0],'"':[6,0],"[":[4,2],"]":[1,3],o:8,l:[4,0]},pathStateMachine[5]={"'":[4,0],o:8,l:[5,0]},pathStateMachine[6]={'"':[4,0],o:8,l:[6,0]};const literalValueRE=/^\s?(?:true|false|-?[\d.]+|'[^']*'|"[^"]*")\s?$/;function isLiteral(e){return literalValueRE.test(e)}function stripQuotes(e){const t=e.charCodeAt(0);return t!==e.charCodeAt(e.length-1)||34!==t&&39!==t?e:e.slice(1,-1)}function getPathCharType(e){if(null==e)return"o";switch(e.charCodeAt(0)){case 91:case 93:case 46:case 34:case 39:return e;case 95:case 36:case 45:return"i";case 9:case 10:case 13:case 160:case 65279:case 8232:case 8233:return"w"}return"i"}function formatSubPath(e){const t=e.trim();return("0"!==e.charAt(0)||!isNaN(parseInt(e)))&&(isLiteral(t)?stripQuotes(t):"*"+t)}function parse(e){const t=[];let n,r,a,o,s,i,l,c=-1,u=0,m=0;const f=[];function p(){const t=e[c+1];if(5===u&&"'"===t||6===u&&'"'===t)return c++,a="\\"+t,f[0](),!0}for(f[0]=()=>{void 0===r?r=a:r+=a},f[1]=()=>{void 0!==r&&(t.push(r),r=void 0)},f[2]=()=>{f[0](),m++},f[3]=()=>{if(m>0)m--,u=4,f[0]();else{if(m=0,void 0===r)return!1;if(r=formatSubPath(r),!1===r)return!1;f[1]()}};null!==u;)if(c++,n=e[c],"\\"!==n||!p()){if(o=getPathCharType(n),l=pathStateMachine[u],s=l[o]||l.l||8,8===s)return;if(u=s[0],void 0!==s[1]&&(i=f[s[1]],i&&(a=n,!1===i())))return;if(7===u)return t}}const cache=new Map;function resolveWithKeyValue(e,t){return isObject(e)?e[t]:null}function resolveValue(e,t){if(!isObject(e))return null;let n=cache.get(t);if(n||(n=parse(t),n&&cache.set(t,n)),!n)return null;const r=n.length;let a=e,o=0;for(;o<r;){const e=a[n[o]];if(void 0===e)return null;if(isFunction(a))return null;a=e,o++}return a}const DEFAULT_MODIFIER=e=>e,DEFAULT_MESSAGE=e=>"",DEFAULT_MESSAGE_DATA_TYPE="text",DEFAULT_NORMALIZE=e=>0===e.length?"":join(e),DEFAULT_INTERPOLATE=toDisplayString;function pluralDefault(e,t){return e=Math.abs(e),2===t?e?e>1?1:0:1:e?Math.min(e,2):0}function getPluralIndex(e){const t=isNumber(e.pluralIndex)?e.pluralIndex:-1;return e.named&&(isNumber(e.named.count)||isNumber(e.named.n))?isNumber(e.named.count)?e.named.count:isNumber(e.named.n)?e.named.n:t:t}function normalizeNamed(e,t){t.count||(t.count=e),t.n||(t.n=e)}function createMessageContext(e={}){const t=e.locale,n=getPluralIndex(e),r=isObject(e.pluralRules)&&isString(t)&&isFunction(e.pluralRules[t])?e.pluralRules[t]:pluralDefault,a=isObject(e.pluralRules)&&isString(t)&&isFunction(e.pluralRules[t])?pluralDefault:void 0,o=e.list||[],s=e.named||{};isNumber(e.pluralIndex)&&normalizeNamed(n,s);function i(t){const n=isFunction(e.messages)?e.messages(t):!!isObject(e.messages)&&e.messages[t];return n||(e.parent?e.parent.message(t):DEFAULT_MESSAGE)}const l=isPlainObject(e.processor)&&isFunction(e.processor.normalize)?e.processor.normalize:DEFAULT_NORMALIZE,c=isPlainObject(e.processor)&&isFunction(e.processor.interpolate)?e.processor.interpolate:DEFAULT_INTERPOLATE,u={list:e=>o[e],named:e=>s[e],plural:e=>e[r(n,e.length,a)],linked:(t,...n)=>{const[r,a]=n;let o="text",s="";1===n.length?isObject(r)?(s=r.modifier||s,o=r.type||o):isString(r)&&(s=r||s):2===n.length&&(isString(r)&&(s=r||s),isString(a)&&(o=a||o));const l=i(t)(u),c="vnode"===o&&isArray(l)&&s?l[0]:l;return s?(m=s,e.modifiers?e.modifiers[m]:DEFAULT_MODIFIER)(c,o):c;var m},message:i,type:isPlainObject(e.processor)&&isString(e.processor.type)?e.processor.type:DEFAULT_MESSAGE_DATA_TYPE,interpolate:c,normalize:l,values:assign({},o,s)};return u}const code$1=CompileErrorCodes.__EXTEND_POINT__,inc$1=incrementer(code$1),CoreErrorCodes={INVALID_ARGUMENT:code$1,INVALID_DATE_ARGUMENT:inc$1(),INVALID_ISO_DATE_ARGUMENT:inc$1(),NOT_SUPPORT_NON_STRING_MESSAGE:inc$1(),NOT_SUPPORT_LOCALE_PROMISE_VALUE:inc$1(),NOT_SUPPORT_LOCALE_ASYNC_FUNCTION:inc$1(),NOT_SUPPORT_LOCALE_TYPE:inc$1(),__EXTEND_POINT__:inc$1()};function getLocale(e,t){return null!=t.locale?resolveLocale(t.locale):resolveLocale(e.locale)}let _resolveLocale;function resolveLocale(e){if(isString(e))return e;if(isFunction(e)){if(e.resolvedOnce&&null!=_resolveLocale)return _resolveLocale;if("Function"===e.constructor.name){const t=e();if(isPromise(t))throw Error(CoreErrorCodes.NOT_SUPPORT_LOCALE_PROMISE_VALUE);return _resolveLocale=t}throw Error(CoreErrorCodes.NOT_SUPPORT_LOCALE_ASYNC_FUNCTION)}throw Error(CoreErrorCodes.NOT_SUPPORT_LOCALE_TYPE)}function fallbackWithSimple(e,t,n){return[...new Set([n,...isArray(t)?t:isObject(t)?Object.keys(t):isString(t)?[t]:[n]])]}function fallbackWithLocaleChain(e,t,n){const r=isString(n)?n:DEFAULT_LOCALE,a=e;a.__localeChainCache||(a.__localeChainCache=new Map);let o=a.__localeChainCache.get(r);if(!o){o=[];let e=[n];for(;isArray(e);)e=appendBlockToChain(o,e,t);const s=isArray(t)||!isPlainObject(t)?t:t.default?t.default:null;e=isString(s)?[s]:s,isArray(e)&&appendBlockToChain(o,e,!1),a.__localeChainCache.set(r,o)}return o}function appendBlockToChain(e,t,n){let r=!0;for(let a=0;a<t.length&&isBoolean(r);a++){const o=t[a];isString(o)&&(r=appendLocaleToChain(e,t[a],n))}return r}function appendLocaleToChain(e,t,n){let r;const a=t.split("-");do{r=appendItemToChain(e,a.join("-"),n),a.splice(-1,1)}while(a.length&&!0===r);return r}function appendItemToChain(e,t,n){let r=!1;if(!e.includes(t)&&(r=!0,t)){r="!"!==t[t.length-1];const a=t.replace(/!/g,"");e.push(a),(isArray(n)||isPlainObject(n))&&n[a]&&(r=n[a])}return r}const VERSION$1="9.14.1",NOT_REOSLVED=-1,DEFAULT_LOCALE="en-US",MISSING_RESOLVE_VALUE="",capitalize=e=>`${e.charAt(0).toLocaleUpperCase()}${e.substr(1)}`;function getDefaultLinkedModifiers(){return{upper:(e,t)=>"text"===t&&isString(e)?e.toUpperCase():"vnode"===t&&isObject(e)&&"__v_isVNode"in e?e.children.toUpperCase():e,lower:(e,t)=>"text"===t&&isString(e)?e.toLowerCase():"vnode"===t&&isObject(e)&&"__v_isVNode"in e?e.children.toLowerCase():e,capitalize:(e,t)=>"text"===t&&isString(e)?capitalize(e):"vnode"===t&&isObject(e)&&"__v_isVNode"in e?capitalize(e.children):e}}let _compiler,_resolver,_fallbacker;function registerMessageCompiler(e){_compiler=e}function registerMessageResolver(e){_resolver=e}function registerLocaleFallbacker(e){_fallbacker=e}const setAdditionalMeta=e=>{};let _fallbackContext=null;const setFallbackContext=e=>{_fallbackContext=e},getFallbackContext=()=>_fallbackContext;let _cid=0;function createCoreContext(e={}){const t=isFunction(e.onWarn)?e.onWarn:warn,n=isString(e.version)?e.version:VERSION$1,r=isString(e.locale)||isFunction(e.locale)?e.locale:DEFAULT_LOCALE,a=isFunction(r)?DEFAULT_LOCALE:r,o=isArray(e.fallbackLocale)||isPlainObject(e.fallbackLocale)||isString(e.fallbackLocale)||!1===e.fallbackLocale?e.fallbackLocale:a,s=isPlainObject(e.messages)?e.messages:{[a]:{}},i=isPlainObject(e.datetimeFormats)?e.datetimeFormats:{[a]:{}},l=isPlainObject(e.numberFormats)?e.numberFormats:{[a]:{}},c=assign({},e.modifiers||{},getDefaultLinkedModifiers()),u=e.pluralRules||{},m=isFunction(e.missing)?e.missing:null,f=!isBoolean(e.missingWarn)&&!isRegExp(e.missingWarn)||e.missingWarn,p=!isBoolean(e.fallbackWarn)&&!isRegExp(e.fallbackWarn)||e.fallbackWarn,_=!!e.fallbackFormat,g=!!e.unresolving,d=isFunction(e.postTranslation)?e.postTranslation:null,E=isPlainObject(e.processor)?e.processor:null,b=!isBoolean(e.warnHtmlMessage)||e.warnHtmlMessage,C=!!e.escapeParameter,N=isFunction(e.messageCompiler)?e.messageCompiler:_compiler,L=isFunction(e.messageResolver)?e.messageResolver:_resolver||resolveWithKeyValue,O=isFunction(e.localeFallbacker)?e.localeFallbacker:_fallbacker||fallbackWithSimple,h=isObject(e.fallbackContext)?e.fallbackContext:void 0,T=e,v=isObject(T.__datetimeFormatters)?T.__datetimeFormatters:new Map,y=isObject(T.__numberFormatters)?T.__numberFormatters:new Map,S=isObject(T.__meta)?T.__meta:{};_cid++;const k={version:n,cid:_cid,locale:r,fallbackLocale:o,messages:s,modifiers:c,pluralRules:u,missing:m,missingWarn:f,fallbackWarn:p,fallbackFormat:_,unresolving:g,postTranslation:d,processor:E,warnHtmlMessage:b,escapeParameter:C,messageCompiler:N,messageResolver:L,localeFallbacker:O,fallbackContext:h,onWarn:t,__meta:S};return k.datetimeFormats=i,k.numberFormats=l,k.__datetimeFormatters=v,k.__numberFormatters=y,k}function handleMissing(e,t,n,r,a){const{missing:o,onWarn:s}=e;if(null!==o){const r=o(e,n,t,a);return isString(r)?r:t}return t}function updateFallbackLocale(e,t,n){e.__localeChainCache=new Map,e.localeFallbacker(e,n,t)}function isAlmostSameLocale(e,t){return e!==t&&e.split("-")[0]===t.split("-")[0]}function isImplicitFallback(e,t){const n=t.indexOf(e);if(-1===n)return!1;for(let r=n+1;r<t.length;r++)if(isAlmostSameLocale(e,t[r]))return!0;return!1}function format(e){return t=>formatParts(t,e)}function formatParts(e,t){const n=t.b||t.body;if(1===(n.t||n.type)){const t=n,r=t.c||t.cases;return e.plural(r.reduce(((t,n)=>[...t,formatMessageParts(e,n)]),[]))}return formatMessageParts(e,n)}function formatMessageParts(e,t){const n=t.s||t.static;if(n)return"text"===e.type?n:e.normalize([n]);{const n=(t.i||t.items).reduce(((t,n)=>[...t,formatMessagePart(e,n)]),[]);return e.normalize(n)}}function formatMessagePart(e,t){const n=t.t||t.type;switch(n){case 3:{const e=t;return e.v||e.value}case 9:{const e=t;return e.v||e.value}case 4:{const n=t;return e.interpolate(e.named(n.k||n.key))}case 5:{const n=t;return e.interpolate(e.list(null!=n.i?n.i:n.index))}case 6:{const n=t,r=n.m||n.modifier;return e.linked(formatMessagePart(e,n.k||n.key),r?formatMessagePart(e,r):void 0,e.type)}case 7:{const e=t;return e.v||e.value}case 8:{const e=t;return e.v||e.value}default:throw new Error(`unhandled node type on format message part: ${n}`)}}const defaultOnCacheKey=e=>e;let compileCache=Object.create(null);const isMessageAST=e=>isObject(e)&&(0===e.t||0===e.type)&&("b"in e||"body"in e);function baseCompile(e,t={}){let n=!1;const r=t.onError||defaultOnError;return t.onError=e=>{n=!0,r(e)},{...baseCompile$1(e,t),detectError:n}}function compile(e,t){if(isString(e)){!isBoolean(t.warnHtmlMessage)||t.warnHtmlMessage;const n=(t.onCacheKey||defaultOnCacheKey)(e),r=compileCache[n];if(r)return r;const{ast:a,detectError:o}=baseCompile(e,{...t,location:!1,jit:!0}),s=format(a);return o?s:compileCache[n]=s}{const t=e.cacheKey;if(t){const n=compileCache[t];return n||(compileCache[t]=format(e))}return format(e)}}const NOOP_MESSAGE_FUNCTION=()=>"",isMessageFunction=e=>isFunction(e);function translate(e,...t){const{fallbackFormat:n,postTranslation:r,unresolving:a,messageCompiler:o,fallbackLocale:s,messages:i}=e,[l,c]=parseTranslateArgs(...t),u=isBoolean(c.missingWarn)?c.missingWarn:e.missingWarn,m=isBoolean(c.fallbackWarn)?c.fallbackWarn:e.fallbackWarn,f=isBoolean(c.escapeParameter)?c.escapeParameter:e.escapeParameter,p=!!c.resolvedMessage,_=isString(c.default)||isBoolean(c.default)?isBoolean(c.default)?o?l:()=>l:c.default:n?o?l:()=>l:"",g=n||""!==_,d=getLocale(e,c);f&&escapeParams(c);let[E,b,C]=p?[l,d,i[d]||{}]:resolveMessageFormat(e,l,d,s,m,u),N=E,L=l;if(p||isString(N)||isMessageAST(N)||isMessageFunction(N)||g&&(N=_,L=N),!(p||(isString(N)||isMessageAST(N)||isMessageFunction(N))&&isString(b)))return a?NOT_REOSLVED:l;let O=!1;const h=isMessageFunction(N)?N:compileMessageFormat(e,l,b,N,L,(()=>{O=!0}));if(O)return N;const T=evaluateMessage(e,h,createMessageContext(getMessageContextOptions(e,b,C,c)));return r?r(T,l):T}function escapeParams(e){isArray(e.list)?e.list=e.list.map((e=>isString(e)?escapeHtml(e):e)):isObject(e.named)&&Object.keys(e.named).forEach((t=>{isString(e.named[t])&&(e.named[t]=escapeHtml(e.named[t]))}))}function resolveMessageFormat(e,t,n,r,a,o){const{messages:s,onWarn:i,messageResolver:l,localeFallbacker:c}=e,u=c(e,r,n);let m,f={},p=null;for(let _=0;_<u.length&&(m=u[_],f=s[m]||{},null===(p=l(f,t))&&(p=f[t]),!(isString(p)||isMessageAST(p)||isMessageFunction(p)));_++)if(!isImplicitFallback(m,u)){const n=handleMissing(e,t,m,o,"translate");n!==t&&(p=n)}return[p,m,f]}function compileMessageFormat(e,t,n,r,a,o){const{messageCompiler:s,warnHtmlMessage:i}=e;if(isMessageFunction(r)){const e=r;return e.locale=e.locale||n,e.key=e.key||t,e}if(null==s){const e=()=>r;return e.locale=n,e.key=t,e}const l=s(r,getCompileContext(e,n,a,r,i,o));return l.locale=n,l.key=t,l.source=r,l}function evaluateMessage(e,t,n){return t(n)}function parseTranslateArgs(...e){const[t,n,r]=e,a={};if(!(isString(t)||isNumber(t)||isMessageFunction(t)||isMessageAST(t)))throw Error(CoreErrorCodes.INVALID_ARGUMENT);const o=isNumber(t)?String(t):(isMessageFunction(t),t);return isNumber(n)?a.plural=n:isString(n)?a.default=n:isPlainObject(n)&&!isEmptyObject(n)?a.named=n:isArray(n)&&(a.list=n),isNumber(r)?a.plural=r:isString(r)?a.default=r:isPlainObject(r)&&assign(a,r),[o,a]}function getCompileContext(e,t,n,r,a,o){return{locale:t,key:n,warnHtmlMessage:a,onError:e=>{throw o&&o(e),e},onCacheKey:e=>generateFormatCacheKey(t,n,e)}}function getMessageContextOptions(e,t,n,r){const{modifiers:a,pluralRules:o,messageResolver:s,fallbackLocale:i,fallbackWarn:l,missingWarn:c,fallbackContext:u}=e,m={locale:t,modifiers:a,pluralRules:o,messages:r=>{let a=s(n,r);if(null==a&&u){const[,,e]=resolveMessageFormat(u,r,t,i,l,c);a=s(e,r)}if(isString(a)||isMessageAST(a)){let n=!1;const o=compileMessageFormat(e,r,t,a,r,(()=>{n=!0}));return n?NOOP_MESSAGE_FUNCTION:o}return isMessageFunction(a)?a:NOOP_MESSAGE_FUNCTION}};return e.processor&&(m.processor=e.processor),r.list&&(m.list=r.list),r.named&&(m.named=r.named),isNumber(r.plural)&&(m.pluralIndex=r.plural),m}function datetime(e,...t){const{datetimeFormats:n,unresolving:r,fallbackLocale:a,onWarn:o,localeFallbacker:s}=e,{__datetimeFormatters:i}=e,[l,c,u,m]=parseDateTimeArgs(...t),f=isBoolean(u.missingWarn)?u.missingWarn:e.missingWarn;isBoolean(u.fallbackWarn)?u.fallbackWarn:e.fallbackWarn;const p=!!u.part,_=getLocale(e,u),g=s(e,a,_);if(!isString(l)||""===l)return new Intl.DateTimeFormat(_,m).format(c);let d,E={},b=null;for(let L=0;L<g.length&&(d=g[L],E=n[d]||{},b=E[l],!isPlainObject(b));L++)handleMissing(e,l,d,f,"datetime format");if(!isPlainObject(b)||!isString(d))return r?NOT_REOSLVED:l;let C=`${d}__${l}`;isEmptyObject(m)||(C=`${C}__${JSON.stringify(m)}`);let N=i.get(C);return N||(N=new Intl.DateTimeFormat(d,assign({},b,m)),i.set(C,N)),p?N.formatToParts(c):N.format(c)}const DATETIME_FORMAT_OPTIONS_KEYS=["localeMatcher","weekday","era","year","month","day","hour","minute","second","timeZoneName","formatMatcher","hour12","timeZone","dateStyle","timeStyle","calendar","dayPeriod","numberingSystem","hourCycle","fractionalSecondDigits"];function parseDateTimeArgs(...e){const[t,n,r,a]=e,o={};let s,i={};if(isString(t)){const e=t.match(/(\d{4}-\d{2}-\d{2})(T|\s)?(.*)/);if(!e)throw Error(CoreErrorCodes.INVALID_ISO_DATE_ARGUMENT);const n=e[3]?e[3].trim().startsWith("T")?`${e[1].trim()}${e[3].trim()}`:`${e[1].trim()}T${e[3].trim()}`:e[1].trim();s=new Date(n);try{s.toISOString()}catch(l){throw Error(CoreErrorCodes.INVALID_ISO_DATE_ARGUMENT)}}else if(isDate(t)){if(isNaN(t.getTime()))throw Error(CoreErrorCodes.INVALID_DATE_ARGUMENT);s=t}else{if(!isNumber(t))throw Error(CoreErrorCodes.INVALID_ARGUMENT);s=t}return isString(n)?o.key=n:isPlainObject(n)&&Object.keys(n).forEach((e=>{DATETIME_FORMAT_OPTIONS_KEYS.includes(e)?i[e]=n[e]:o[e]=n[e]})),isString(r)?o.locale=r:isPlainObject(r)&&(i=r),isPlainObject(a)&&(i=a),[o.key||"",s,o,i]}function clearDateTimeFormat(e,t,n){const r=e;for(const a in n){const e=`${t}__${a}`;r.__datetimeFormatters.has(e)&&r.__datetimeFormatters.delete(e)}}function number(e,...t){const{numberFormats:n,unresolving:r,fallbackLocale:a,onWarn:o,localeFallbacker:s}=e,{__numberFormatters:i}=e,[l,c,u,m]=parseNumberArgs(...t),f=isBoolean(u.missingWarn)?u.missingWarn:e.missingWarn;isBoolean(u.fallbackWarn)?u.fallbackWarn:e.fallbackWarn;const p=!!u.part,_=getLocale(e,u),g=s(e,a,_);if(!isString(l)||""===l)return new Intl.NumberFormat(_,m).format(c);let d,E={},b=null;for(let L=0;L<g.length&&(d=g[L],E=n[d]||{},b=E[l],!isPlainObject(b));L++)handleMissing(e,l,d,f,"number format");if(!isPlainObject(b)||!isString(d))return r?NOT_REOSLVED:l;let C=`${d}__${l}`;isEmptyObject(m)||(C=`${C}__${JSON.stringify(m)}`);let N=i.get(C);return N||(N=new Intl.NumberFormat(d,assign({},b,m)),i.set(C,N)),p?N.formatToParts(c):N.format(c)}const NUMBER_FORMAT_OPTIONS_KEYS=["localeMatcher","style","currency","currencyDisplay","currencySign","useGrouping","minimumIntegerDigits","minimumFractionDigits","maximumFractionDigits","minimumSignificantDigits","maximumSignificantDigits","compactDisplay","notation","signDisplay","unit","unitDisplay","roundingMode","roundingPriority","roundingIncrement","trailingZeroDisplay"];function parseNumberArgs(...e){const[t,n,r,a]=e,o={};let s={};if(!isNumber(t))throw Error(CoreErrorCodes.INVALID_ARGUMENT);const i=t;return isString(n)?o.key=n:isPlainObject(n)&&Object.keys(n).forEach((e=>{NUMBER_FORMAT_OPTIONS_KEYS.includes(e)?s[e]=n[e]:o[e]=n[e]})),isString(r)?o.locale=r:isPlainObject(r)&&(s=r),isPlainObject(a)&&(s=a),[o.key||"",i,o,s]}function clearNumberFormat(e,t,n){const r=e;for(const a in n){const e=`${t}__${a}`;r.__numberFormatters.has(e)&&r.__numberFormatters.delete(e)}}const VERSION="9.14.1",code=CoreErrorCodes.__EXTEND_POINT__,inc=incrementer(code),I18nErrorCodes={UNEXPECTED_RETURN_TYPE:code,INVALID_ARGUMENT:inc(),MUST_BE_CALL_SETUP_TOP:inc(),NOT_INSTALLED:inc(),NOT_AVAILABLE_IN_LEGACY_MODE:inc(),REQUIRED_VALUE:inc(),INVALID_VALUE:inc(),CANNOT_SETUP_VUE_DEVTOOLS_PLUGIN:inc(),NOT_INSTALLED_WITH_PROVIDE:inc(),UNEXPECTED_ERROR:inc(),NOT_COMPATIBLE_LEGACY_VUE_I18N:inc(),BRIDGE_SUPPORT_VUE_2_ONLY:inc(),MUST_DEFINE_I18N_OPTION_IN_ALLOW_COMPOSITION:inc(),NOT_AVAILABLE_COMPOSITION_IN_LEGACY:inc(),__EXTEND_POINT__:inc()},TranslateVNodeSymbol=makeSymbol("__translateVNode"),DatetimePartsSymbol=makeSymbol("__datetimeParts"),NumberPartsSymbol=makeSymbol("__numberParts"),SetPluralRulesSymbol=makeSymbol("__setPluralRules"),LegacyInstanceSymbol=makeSymbol("__legacyVueI18n"),InejctWithOptionSymbol=makeSymbol("__injectWithOption"),DisposeSymbol=makeSymbol("__dispose"),__VUE_I18N_BRIDGE__="__VUE_I18N_BRIDGE__";function isLegacyVueI18n(e){return null!=e&&null!=e.version&&(Number(e.version.split(".")[0])||-1)>=8}function handleFlatJson(e){if(!isObject(e))return e;for(const t in e)if(hasOwn(e,t))if(t.includes(".")){const n=t.split("."),r=n.length-1;let a=e,o=!1;for(let e=0;e<r;e++){if(n[e]in a||(a[n[e]]={}),!isObject(a[n[e]])){o=!0;break}a=a[n[e]]}o||(a[n[r]]=e[t],delete e[t]),isObject(a[n[r]])&&handleFlatJson(a[n[r]])}else isObject(e[t])&&handleFlatJson(e[t]);return e}function getLocaleMessages(e,t){const{messages:n,__i18n:r,messageResolver:a,flatJson:o}=t,s=isPlainObject(n)?n:isArray(r)?{}:{[e]:{}};if(isArray(r)&&r.forEach((e=>{if("locale"in e&&"resource"in e){const{locale:t,resource:n}=e;t?(s[t]=s[t]||{},deepCopy(n,s[t])):deepCopy(n,s)}else isString(e)&&deepCopy(JSON.parse(e),s)})),null==a&&o)for(const i in s)hasOwn(s,i)&&handleFlatJson(s[i]);return s}function getComponentOptions(e){return e.proxy.$options}function adjustI18nResources(e,t,n){let r=isObject(t.messages)?t.messages:{};"__i18nGlobal"in n&&(r=getLocaleMessages(e.locale.value,{messages:r,__i18n:n.__i18nGlobal}));const a=Object.keys(r);if(a.length&&a.forEach((t=>{e.mergeLocaleMessage(t,r[t])})),isObject(t.datetimeFormats)){const n=Object.keys(t.datetimeFormats);n.length&&n.forEach((n=>{e.mergeDateTimeFormat(n,t.datetimeFormats[n])}))}if(isObject(t.numberFormats)){const n=Object.keys(t.numberFormats);n.length&&n.forEach((n=>{e.mergeNumberFormat(n,t.numberFormats[n])}))}}function createTextNode(e){return createVNodeVue2Compatible(e)}function createVNodeVue2Compatible(e){const t=void 0;return{tag:void 0,data:void 0,children:void 0,text:e,elm:void 0,ns:void 0,context:void 0,fnContext:void 0,fnOptions:void 0,fnScopeId:void 0,key:void 0,componentOptions:void 0,componentInstance:t,parent:void 0,raw:!1,isStatic:!1,isRootInsert:!0,isComment:!1,isCloned:!1,isOnce:!1,asyncFactory:void 0,asyncMeta:void 0,isAsyncPlaceholder:!1,child:()=>t}}const DEVTOOLS_META="__INTLIFY_META__",NOOP_RETURN_ARRAY=()=>[],NOOP_RETURN_FALSE=()=>!1;let composerID=0;function defineCoreMissingHandler(e){return(t,n,r,a)=>e(n,r,getCurrentInstance()||void 0,a)}const getMetaInfo=()=>{const e=getCurrentInstance();let t=null;return e&&(t=getComponentOptions(e)[DEVTOOLS_META])?{[DEVTOOLS_META]:t}:null};function createComposer(e={},t){const{__root:n,__injectWithOption:r}=e,a=void 0===n,o=e.flatJson,s=inBrowser?ref:shallowRef,i=!!e.translateExistCompatible;let l=!isBoolean(e.inheritLocale)||e.inheritLocale;const c=s(n&&l?n.locale.value:isString(e.locale)?e.locale:DEFAULT_LOCALE),u=s(n&&l?n.fallbackLocale.value:isString(e.fallbackLocale)||isArray(e.fallbackLocale)||isPlainObject(e.fallbackLocale)||!1===e.fallbackLocale?e.fallbackLocale:c.value),m=s(getLocaleMessages(c.value,e)),f=s(isPlainObject(e.datetimeFormats)?e.datetimeFormats:{[c.value]:{}}),p=s(isPlainObject(e.numberFormats)?e.numberFormats:{[c.value]:{}});let _=n?n.missingWarn:!isBoolean(e.missingWarn)&&!isRegExp(e.missingWarn)||e.missingWarn,g=n?n.fallbackWarn:!isBoolean(e.fallbackWarn)&&!isRegExp(e.fallbackWarn)||e.fallbackWarn,d=n?n.fallbackRoot:!isBoolean(e.fallbackRoot)||e.fallbackRoot,E=!!e.fallbackFormat,b=isFunction(e.missing)?e.missing:null,C=isFunction(e.missing)?defineCoreMissingHandler(e.missing):null,N=isFunction(e.postTranslation)?e.postTranslation:null,L=n?n.warnHtmlMessage:!isBoolean(e.warnHtmlMessage)||e.warnHtmlMessage,O=!!e.escapeParameter;const h=n?n.modifiers:isPlainObject(e.modifiers)?e.modifiers:{};let T,v,y=e.pluralRules||n&&n.pluralRules;{isLegacyVueI18n(t);const e={locale:c.value,fallbackLocale:u.value,messages:m.value,dateTimeFormats:f.value,numberFormats:p.value,modifiers:h,missing:b,fallbackRoot:d,postTranslation:N,pluralizationRules:y,escapeParameterHtml:O,sync:l,silentFallbackWarn:isBoolean(g)?!g:g,silentTranslationWarn:isBoolean(_)?!_:_,formatFallbackMessages:isBoolean(E)?!E:E,warnHtmlInMessage:isBoolean(L)&&L?"warn":"off",__VUE_I18N_BRIDGE__:__VUE_I18N_BRIDGE__};T=new t(e)}v=(()=>{a&&setFallbackContext(null);const t={version:VERSION,locale:c.value,fallbackLocale:u.value,messages:m.value,modifiers:h,pluralRules:y,missing:null===C?void 0:C,missingWarn:_,fallbackWarn:g,fallbackFormat:E,unresolving:!0,postTranslation:null===N?void 0:N,warnHtmlMessage:L,escapeParameter:O,messageResolver:e.messageResolver,messageCompiler:e.messageCompiler,__meta:{framework:"vue"}};t.datetimeFormats=f.value,t.numberFormats=p.value,t.__datetimeFormatters=isPlainObject(v)?v.__datetimeFormatters:void 0,t.__numberFormatters=isPlainObject(v)?v.__numberFormatters:void 0;const n=createCoreContext(t);return a&&setFallbackContext(n),n})(),updateFallbackLocale(v,c.value,u.value);const S=computed({get:()=>c.value,set:e=>{c.value=e,T&&!a&&(T.locale=e),v.locale=c.value}}),k=computed({get:()=>u.value,set:e=>{u.value=e,T&&!a&&(T.fallbackLocale=e),v.fallbackLocale=u.value,updateFallbackLocale(v,c.value,e)}}),I=computed((()=>m.value)),A=computed((()=>f.value)),P=computed((()=>p.value));const F=(e,t,r,o,s,i)=>{let l;c.value,u.value,m.value,f.value,p.value;try{0,a||(v.fallbackContext=n?getFallbackContext():void 0),l=e(v)}finally{a||(v.fallbackContext=void 0)}if("translate exists"!==r&&isNumber(l)&&l===NOT_REOSLVED||"translate exists"===r&&!l){const[e,r]=t();return n&&d?o(n):s(e)}if(i(l))return l;throw Error(I18nErrorCodes.UNEXPECTED_RETURN_TYPE)};function R(...e){return F((t=>Reflect.apply(translate,null,[t,...e])),(()=>parseTranslateArgs(...e)),"translate",(t=>Reflect.apply(t.t,t,[...e])),(e=>e),(e=>isString(e)))}const M={normalize:function(e){return e.map((e=>isString(e)||isNumber(e)||isBoolean(e)?createTextNode(String(e)):e))},interpolate:e=>e,type:"vnode"};function D(e){return m.value[e]||{}}composerID++,n&&inBrowser&&(watch(n.locale,(e=>{l&&(c.value=e,T&&!a&&(T.locale=e),v.locale=e,updateFallbackLocale(v,c.value,u.value))})),watch(n.fallbackLocale,(e=>{l&&(u.value=e,T&&!a&&(T.fallbackLocale=e),v.fallbackLocale=e,updateFallbackLocale(v,c.value,u.value))})));const j={id:composerID,locale:S,fallbackLocale:k,get inheritLocale(){return l},set inheritLocale(e){l=e,T&&(T._sync=e),e&&n&&(c.value=n.locale.value,u.value=n.fallbackLocale.value,T&&(T.locale=n.locale.value,T.fallbackLocale=n.fallbackLocale.value),updateFallbackLocale(v,c.value,u.value))},get availableLocales(){return Object.keys(m.value).sort()},messages:I,get modifiers(){return h},get pluralRules(){return y||{}},get isGlobal(){return a},get missingWarn(){return _},set missingWarn(e){_=e,v.missingWarn=_},get fallbackWarn(){return g},set fallbackWarn(e){g=e,v.fallbackWarn=g},get fallbackRoot(){return d},set fallbackRoot(e){d=e},get fallbackFormat(){return E},set fallbackFormat(e){E=e,v.fallbackFormat=E},get warnHtmlMessage(){return L},set warnHtmlMessage(e){L=e,v.warnHtmlMessage=e},get escapeParameter(){return O},set escapeParameter(e){O=e,v.escapeParameter=e},t:R,getLocaleMessage:D,setLocaleMessage:function(e,t){if(o){const n={[e]:t};for(const e in n)hasOwn(n,e)&&handleFlatJson(n[e]);t=n[e]}m.value[e]=t,T&&T.setLocaleMessage(e,t),v.messages=m.value},mergeLocaleMessage:function(e,t){m.value[e]=m.value[e]||{},T&&T.mergeLocaleMessage(e,t);const n={[e]:t};if(o)for(const r in n)hasOwn(n,r)&&handleFlatJson(n[r]);deepCopy(t=n[e],m.value[e]),v.messages=m.value},getPostTranslationHandler:function(){return isFunction(N)?N:null},setPostTranslationHandler:function(e){N=e,v.postTranslation=e},getMissingHandler:function(){return b},setMissingHandler:function(e){null!==e&&(C=defineCoreMissingHandler(e)),b=e,v.missing=C},[SetPluralRulesSymbol]:function(e){y=e,v.pluralRules=y}};return j.datetimeFormats=A,j.numberFormats=P,j.rt=function(...e){const[t,n,r]=e;if(r&&!isObject(r))throw Error(I18nErrorCodes.INVALID_ARGUMENT);return R(t,n,assign({resolvedMessage:!0},r||{}))},j.te=function(e,t){return F((()=>{if(!e)return!1;const n=D(isString(t)?t:c.value),r=v.messageResolver(n,e);return i?null!=r:isMessageAST(r)||isMessageFunction(r)||isString(r)}),(()=>[e]),"translate exists",(n=>Reflect.apply(n.te,n,[e,t])),NOOP_RETURN_FALSE,(e=>isBoolean(e)))},j.tm=function(e){const t=function(e){let t=null;const n=fallbackWithLocaleChain(v,u.value,c.value);for(let r=0;r<n.length;r++){const a=m.value[n[r]]||{},o=v.messageResolver(a,e);if(null!=o){t=o;break}}return t}(e);return null!=t?t:n&&n.tm(e)||{}},j.d=function(...e){return F((t=>Reflect.apply(datetime,null,[t,...e])),(()=>parseDateTimeArgs(...e)),"datetime format",(t=>Reflect.apply(t.d,t,[...e])),(()=>MISSING_RESOLVE_VALUE),(e=>isString(e)))},j.n=function(...e){return F((t=>Reflect.apply(number,null,[t,...e])),(()=>parseNumberArgs(...e)),"number format",(t=>Reflect.apply(t.n,t,[...e])),(()=>MISSING_RESOLVE_VALUE),(e=>isString(e)))},j.getDateTimeFormat=function(e){return f.value[e]||{}},j.setDateTimeFormat=function(e,t){f.value[e]=t,T&&T.setDateTimeFormat(e,t),v.datetimeFormats=f.value,clearDateTimeFormat(v,e,t)},j.mergeDateTimeFormat=function(e,t){f.value[e]=assign(f.value[e]||{},t),T&&T.mergeDateTimeFormat(e,t),v.datetimeFormats=f.value,clearDateTimeFormat(v,e,t)},j.getNumberFormat=function(e){return p.value[e]||{}},j.setNumberFormat=function(e,t){p.value[e]=t,T&&T.setNumberFormat(e,t),v.numberFormats=p.value,clearNumberFormat(v,e,t)},j.mergeNumberFormat=function(e,t){p.value[e]=assign(p.value[e]||{},t),T&&T.mergeNumberFormat(e,t),v.numberFormats=p.value,clearNumberFormat(v,e,t)},j[InejctWithOptionSymbol]=r,j[TranslateVNodeSymbol]=function(...e){return F((t=>{let n;const r=t;try{r.processor=M,n=Reflect.apply(translate,null,[r,...e])}finally{r.processor=null}return n}),(()=>parseTranslateArgs(...e)),"translate",(t=>t[TranslateVNodeSymbol](...e)),(e=>[createTextNode(e)]),(e=>isArray(e)))},j[DatetimePartsSymbol]=function(...e){return F((t=>Reflect.apply(datetime,null,[t,...e])),(()=>parseDateTimeArgs(...e)),"datetime format",(t=>t[DatetimePartsSymbol](...e)),NOOP_RETURN_ARRAY,(e=>isString(e)||isArray(e)))},j[NumberPartsSymbol]=function(...e){return F((t=>Reflect.apply(number,null,[t,...e])),(()=>parseNumberArgs(...e)),"number format",(t=>t[NumberPartsSymbol](...e)),NOOP_RETURN_ARRAY,(e=>isString(e)||isArray(e)))},j[LegacyInstanceSymbol]=T,j}const baseFormatProps={tag:{type:[String,Object]},locale:{type:String},scope:{type:String,validator:e=>"parent"===e||"global"===e,default:"parent"},i18n:{type:Object}};function getInterpolateArg({slots:e},t){if(1===t.length&&"default"===t[0]){return(e.default?e.default():[]).reduce(((e,t)=>[...e,...t.children?t.children:[t]]),[])}return t.reduce(((t,n)=>{const r=e[n];return r&&(t[n]=r()),t}),{})}function getFragmentableTag(e){return e}const TranslationImpl=defineComponent({name:"i18n-t",props:assign({keypath:{type:String,required:!0},plural:{type:[Number,String],validator:e=>isNumber(e)||!isNaN(e)}},baseFormatProps),setup(e,t){const{slots:n,attrs:r}=t,a=e.i18n||useI18n({useScope:e.scope,__useComponent:!0});return()=>{const o=Object.keys(n).filter((e=>"_"!==e)),s={};e.locale&&(s.locale=e.locale),void 0!==e.plural&&(s.plural=isString(e.plural)?+e.plural:e.plural);const i=getInterpolateArg(t,o),l=a[TranslateVNodeSymbol](e.keypath,i,s),c=assign({},r),u=isString(e.tag)||isObject(e.tag)?e.tag:getFragmentableTag("span");return h(u,c,l)}}}),Translation=TranslationImpl,I18nT=Translation;function isVNode(e){return isArray(e)&&!isString(e[0])}function renderFormatter(e,t,n,r){const{slots:a,attrs:o}=t;return()=>{const t={part:!0};let s={};e.locale&&(t.locale=e.locale),isString(e.format)?t.key=e.format:isObject(e.format)&&(isString(e.format.key)&&(t.key=e.format.key),s=Object.keys(e.format).reduce(((t,r)=>n.includes(r)?assign({},t,{[r]:e.format[r]}):t),{}));const i=r(e.value,t,s);let l=[t.key];isArray(i)?l=i.map(((e,t)=>{const n=a[e.type],r=n?n({[e.type]:e.value,index:t,parts:i}):[e.value];return isVNode(r)&&(r[0].key=`${e.type}-${t}`),r})):isString(i)&&(l=[i]);const c=assign({},o),u=isString(e.tag)||isObject(e.tag)?e.tag:getFragmentableTag("span");return h(u,c,l)}}const NumberFormatImpl=defineComponent({name:"i18n-n",props:assign({value:{type:Number,required:!0},format:{type:[String,Object]}},baseFormatProps),setup(e,t){const n=e.i18n||useI18n({useScope:e.scope,__useComponent:!0});return renderFormatter(e,t,NUMBER_FORMAT_OPTIONS_KEYS,((...e)=>n[NumberPartsSymbol](...e)))}}),NumberFormat=NumberFormatImpl,I18nN=NumberFormat,DatetimeFormatImpl=defineComponent({name:"i18n-d",props:assign({value:{type:[Number,Date],required:!0},format:{type:[String,Object]}},baseFormatProps),setup(e,t){const n=e.i18n||useI18n({useScope:e.scope,__useComponent:!0});return renderFormatter(e,t,DATETIME_FORMAT_OPTIONS_KEYS,((...e)=>n[DatetimePartsSymbol](...e)))}}),DatetimeFormat=DatetimeFormatImpl,I18nD=DatetimeFormat;function apply(e,...t){const n=isPlainObject(t[0])?t[0]:{};(!isBoolean(n.globalInstall)||n.globalInstall)&&(e.component(Translation.name,Translation),e.component(NumberFormat.name,NumberFormat),e.component(DatetimeFormat.name,DatetimeFormat))}function defineMixin(e,t){return{beforeCreate(){const n=this.$options;if(!n.__VUE18N__INSTANCE__)if(n.i18n=n.i18n||(n.__i18nBridge?{}:null),this._i18nBridgeRoot=e,"composition"!==e.mode)if(n.i18n){if(n.i18n instanceof t){if(n.__i18nBridge)try{const e=n.i18n&&n.i18n.messages?n.i18n.messages:{};n.__i18nBridge.forEach((t=>deepCopy(JSON.parse(t),e))),Object.keys(e).forEach((t=>{n.i18n.mergeLocaleMessage(t,e[t])}))}catch(r){}this._i18n=n.i18n,this._i18nWatcher=this._i18n.watchI18nData()}else if(isPlainObject(n.i18n)){const e=this.$root&&this.$root.$i18n&&this.$root.$i18n instanceof t?this.$root.$i18n:null;if(e&&(n.i18n.root=this.$root,n.i18n.formatter=e.formatter,n.i18n.fallbackLocale=e.fallbackLocale,n.i18n.formatFallbackMessages=e.formatFallbackMessages,n.i18n.silentTranslationWarn=e.silentTranslationWarn,n.i18n.silentFallbackWarn=e.silentFallbackWarn,n.i18n.pluralizationRules=e.pluralizationRules,n.i18n.preserveDirectiveContent=e.preserveDirectiveContent),n.__i18nBridge)try{const e=n.i18n&&n.i18n.messages?n.i18n.messages:{};n.__i18nBridge.forEach((t=>deepCopy(JSON.parse(t),e))),n.i18n.messages=e}catch(r){}const{sharedMessages:a}=n.i18n;a&&isPlainObject(a)&&deepCopy(a,n.i18n.messages),this._i18n=new t(n.i18n),this._i18nWatcher=this._i18n.watchI18nData(),(void 0===n.i18n.sync||n.i18n.sync)&&(this._localeWatcher=this.$i18n.watchLocale()),e&&e.onComponentInstanceCreated(this._i18n)}}else this.$root&&this.$root.$i18n&&this.$root.$i18n instanceof t?this._i18n=this.$root.$i18n:n.parent&&n.parent.$i18n&&n.parent.$i18n instanceof t&&(this._i18n=n.parent.$i18n);else this._i18n=e},beforeMount(){const n=this.$options;n.__VUE18N__INSTANCE__||"composition"!==e.mode&&(n.i18n=n.i18n||(n.__i18nBridge?{}:null),n.i18n?(n.i18n instanceof t||isPlainObject(n.i18n))&&(this._i18n.subscribeDataChanging(this),this._subscribing=!0):(this.$root&&this.$root.$i18n&&this.$root.$i18n instanceof t||n.parent&&n.parent.$i18n&&n.parent.$i18n instanceof t)&&(this._i18n.subscribeDataChanging(this),this._subscribing=!0))},beforeDestroy(){if(this.$options.__VUE18N__INSTANCE__)return;if(this._i18nBridgeRoot)return void delete this._i18nBridgeRoot;if("composition"===e.mode)return void delete this._i18n;if(!this._i18n)return;const t=this;this.$nextTick((()=>{t._subscribing&&(t._i18n.unsubscribeDataChanging(t),delete t._subscribing),t._i18nWatcher&&(t._i18nWatcher(),t._i18n.destroyVM(),delete t._i18nWatcher),t._localeWatcher&&(t._localeWatcher(),delete t._localeWatcher)}))}}}let _legacyVueI18n=null;const I18nInjectionKey=makeSymbol("global-vue-i18n");function createI18n(e={},t){_legacyVueI18n=t;const n=!isBoolean(e.legacy)||e.legacy,r=!isBoolean(e.globalInjection)||e.globalInjection,a=!n||!!e.allowComposition,o=new Map,[s,i]=createGlobal(e,n,t);{const e=i[LegacyInstanceSymbol];let t=null;Object.defineProperty(e,"global",{get:()=>i}),Object.defineProperty(e,"mode",{get:()=>n?"legacy":"composition"}),Object.defineProperty(e,"allowComposition",{get:()=>a}),Object.defineProperty(e,"__instances",{get:()=>o}),Object.defineProperty(e,"install",{writable:!0,value:(a,...o)=>{if(2!==(a&&a.version&&Number(a.version.split(".")[0])||-1))throw Error(I18nErrorCodes.BRIDGE_SUPPORT_VUE_2_ONLY);apply(a,...o),!n&&r&&(t=injectGlobalFieldsForBridge(a,e,i)),a.mixin(defineMixin(e,_legacyVueI18n))}}),Object.defineProperty(e,"dispose",{value:()=>{t&&t(),s.stop()}});const l={__getInstance:function(e){return o.get(e)||null},__setInstance:function(e,t){o.set(e,t)},__deleteInstance:function(e){o.delete(e)}};return Object.keys(l).forEach((t=>Object.defineProperty(e,t,{value:l[t]}))),e}}function useI18n(e={}){const t=getCurrentInstance();if(null==t)throw Error(I18nErrorCodes.MUST_BE_CALL_SETUP_TOP);if(null==_legacyVueI18n)throw Error(I18nErrorCodes.NOT_INSTALLED);const n=getI18nInstance(t),r=getGlobalComposer(n),a=getComponentOptions(t),o=getScope(e,a);if("legacy"===n.mode&&!e.__useComponent){if(!n.allowComposition)throw Error(I18nErrorCodes.NOT_AVAILABLE_IN_LEGACY_MODE);return useI18nForLegacy(t,o,r,e)}if("global"===o)return adjustI18nResources(r,e,a),r;if("parent"===o){let a=getComposer(n,t,e.__useComponent);return null==a&&(a=r),a}const s=n;let i=s.__getInstance(t);if(null==i){const n=assign({},e);"__i18n"in a&&(n.__i18n=a.__i18n),r&&(n.__root=r),i=createComposer(n,_legacyVueI18n),s.__composerExtend&&(i[DisposeSymbol]=s.__composerExtend(i)),setupLifeCycle(s,t,i),s.__setInstance(t,i)}return i}const castToVueI18n=e=>{if(!(__VUE_I18N_BRIDGE__ in e))throw Error(I18nErrorCodes.NOT_COMPATIBLE_LEGACY_VUE_I18N);return e};function createGlobal(e,t,n){const r=effectScope();{if(!isLegacyVueI18n(n))throw Error(I18nErrorCodes.NOT_COMPATIBLE_LEGACY_VUE_I18N);const t=r.run((()=>createComposer(e,n)));if(null==t)throw Error(I18nErrorCodes.UNEXPECTED_ERROR);return[r,t]}}function getI18nInstance(e){{const t=e.proxy;if(null==t)throw Error(I18nErrorCodes.UNEXPECTED_ERROR);const n=t._i18nBridgeRoot;if(!n)throw Error(I18nErrorCodes.NOT_INSTALLED);return n}}function getScope(e,t){return isEmptyObject(e)?"__i18n"in t?"local":"global":e.useScope?e.useScope:"local"}function getGlobalComposer(e){return e.global}function getComposer(e,t,n=!1){let r=null;const a=t.root;let o=getParentComponentInstance(t,n);for(;null!=o;){const t=e;if("composition"===e.mode)r=t.__getInstance(o);else{const e=t.__getInstance(o);null!=e&&(r=e.__composer,n&&r&&!r[InejctWithOptionSymbol]&&(r=null))}if(null!=r)break;if(a===o)break;o=o.parent}return r}function getParentComponentInstance(e,t=!1){return null==e?null:e.parent}function setupLifeCycle(e,t,n){{const r=t.proxy;if(null==r)throw Error(I18nErrorCodes.UNEXPECTED_ERROR);const a=n[LegacyInstanceSymbol];if(a===e)throw Error(I18nErrorCodes.UNEXPECTED_ERROR);r._i18n=a,r._i18n_bridge=!0,inBrowser&&(r._i18nWatcher=r._i18n.watchI18nData(),r._i18n._sync&&(r._localeWatcher=r._i18n.watchLocale()));let o=!1;onBeforeMount((()=>{r._i18n.subscribeDataChanging(r),o=!0})),onUnmounted((()=>{o&&(r._i18n.unsubscribeDataChanging(r),o=!1),r._i18nWatcher&&(r._i18nWatcher(),r._i18n.destroyVM(),delete r._i18nWatcher),r._localeWatcher&&(r._localeWatcher(),delete r._localeWatcher),delete r._i18n_bridge,delete r._i18n}))}}function useI18nForLegacy(e,t,n,r={}){const a="local"===t,o=shallowRef(null);if(a&&e.proxy&&!e.proxy.$options.i18n&&!e.proxy.$options.__i18n)throw Error(I18nErrorCodes.MUST_DEFINE_I18N_OPTION_IN_ALLOW_COMPOSITION);const s=isBoolean(r.inheritLocale)?r.inheritLocale:!isString(r.locale),i=ref(!a||s?n.locale.value:isString(r.locale)?r.locale:DEFAULT_LOCALE),l=ref(!a||s?n.fallbackLocale.value:isString(r.fallbackLocale)||isArray(r.fallbackLocale)||isPlainObject(r.fallbackLocale)||!1===r.fallbackLocale?r.fallbackLocale:i.value),c=ref(getLocaleMessages(i.value,r)),u=ref(isPlainObject(r.datetimeFormats)?r.datetimeFormats:{[i.value]:{}}),m=ref(isPlainObject(r.numberFormats)?r.numberFormats:{[i.value]:{}}),f=a?n.missingWarn:!isBoolean(r.missingWarn)&&!isRegExp(r.missingWarn)||r.missingWarn,p=a?n.fallbackWarn:!isBoolean(r.fallbackWarn)&&!isRegExp(r.fallbackWarn)||r.fallbackWarn,_=a?n.fallbackRoot:!isBoolean(r.fallbackRoot)||r.fallbackRoot,g=!!r.fallbackFormat,d=isFunction(r.missing)?r.missing:null,E=isFunction(r.postTranslation)?r.postTranslation:null,b=a?n.warnHtmlMessage:!isBoolean(r.warnHtmlMessage)||r.warnHtmlMessage,C=!!r.escapeParameter,N=a?n.modifiers:isPlainObject(r.modifiers)?r.modifiers:{},L=r.pluralRules||a&&n.pluralRules;function O(e){return i.value,l.value,c.value,u.value,m.value,e()}const h={get id(){return o.value?o.value.id:-1},locale:computed({get:()=>o.value?o.value.locale.value:i.value,set:e=>{o.value&&(o.value.locale.value=e),i.value=e}}),fallbackLocale:computed({get:()=>o.value?o.value.fallbackLocale.value:l.value,set:e=>{o.value&&(o.value.fallbackLocale.value=e),l.value=e}}),messages:computed((()=>o.value?o.value.messages.value:c.value)),datetimeFormats:computed((()=>u.value)),numberFormats:computed((()=>m.value)),get inheritLocale(){return o.value?o.value.inheritLocale:s},set inheritLocale(e){o.value&&(o.value.inheritLocale=e)},get availableLocales(){return o.value?o.value.availableLocales:Object.keys(c.value)},get modifiers(){return o.value?o.value.modifiers:N},get pluralRules(){return o.value?o.value.pluralRules:L},get isGlobal(){return!!o.value&&o.value.isGlobal},get missingWarn(){return o.value?o.value.missingWarn:f},set missingWarn(e){o.value&&(o.value.missingWarn=e)},get fallbackWarn(){return o.value?o.value.fallbackWarn:p},set fallbackWarn(e){o.value&&(o.value.missingWarn=e)},get fallbackRoot(){return o.value?o.value.fallbackRoot:_},set fallbackRoot(e){o.value&&(o.value.fallbackRoot=e)},get fallbackFormat(){return o.value?o.value.fallbackFormat:g},set fallbackFormat(e){o.value&&(o.value.fallbackFormat=e)},get warnHtmlMessage(){return o.value?o.value.warnHtmlMessage:b},set warnHtmlMessage(e){o.value&&(o.value.warnHtmlMessage=e)},get escapeParameter(){return o.value?o.value.escapeParameter:C},set escapeParameter(e){o.value&&(o.value.escapeParameter=e)},t:function(...e){return o.value?O((()=>Reflect.apply(o.value.t,null,[...e]))):O((()=>""))},getPostTranslationHandler:function(){return o.value?o.value.getPostTranslationHandler():E},setPostTranslationHandler:function(e){o.value&&o.value.setPostTranslationHandler(e)},getMissingHandler:function(){return o.value?o.value.getMissingHandler():d},setMissingHandler:function(e){o.value&&o.value.setMissingHandler(e)},rt:function(...e){return o.value?Reflect.apply(o.value.rt,null,[...e]):""},d:function(...e){return o.value?O((()=>Reflect.apply(o.value.d,null,[...e]))):O((()=>""))},n:function(...e){return o.value?O((()=>Reflect.apply(o.value.n,null,[...e]))):O((()=>""))},tm:function(e){return o.value?o.value.tm(e):{}},te:function(e,t){return!!o.value&&o.value.te(e,t)},getLocaleMessage:function(e){return o.value?o.value.getLocaleMessage(e):{}},setLocaleMessage:function(e,t){o.value&&(o.value.setLocaleMessage(e,t),c.value[e]=t)},mergeLocaleMessage:function(e,t){o.value&&o.value.mergeLocaleMessage(e,t)},getDateTimeFormat:function(e){return o.value?o.value.getDateTimeFormat(e):{}},setDateTimeFormat:function(e,t){o.value&&(o.value.setDateTimeFormat(e,t),u.value[e]=t)},mergeDateTimeFormat:function(e,t){o.value&&o.value.mergeDateTimeFormat(e,t)},getNumberFormat:function(e){return o.value?o.value.getNumberFormat(e):{}},setNumberFormat:function(e,t){o.value&&(o.value.setNumberFormat(e,t),m.value[e]=t)},mergeNumberFormat:function(e,t){o.value&&o.value.mergeNumberFormat(e,t)}};return onBeforeMount((()=>{if(null==e.proxy||null==e.proxy.$i18n)throw Error(I18nErrorCodes.NOT_AVAILABLE_COMPOSITION_IN_LEGACY);const n=o.value=e.proxy.$i18n.__composer;"global"===t?(i.value=n.locale.value,l.value=n.fallbackLocale.value,c.value=n.messages.value,u.value=n.datetimeFormats.value,m.value=n.numberFormats.value):a&&function(e){e.locale.value=i.value,e.fallbackLocale.value=l.value,Object.keys(c.value).forEach((t=>{e.mergeLocaleMessage(t,c.value[t])})),Object.keys(u.value).forEach((t=>{e.mergeDateTimeFormat(t,u.value[t])})),Object.keys(m.value).forEach((t=>{e.mergeNumberFormat(t,m.value[t])})),e.escapeParameter=C,e.fallbackFormat=g,e.fallbackRoot=_,e.fallbackWarn=p,e.missingWarn=f,e.warnHtmlMessage=b}(n)})),h}function injectGlobalFieldsForBridge(e,t,n){const r=t.watchLocale(n);return e.prototype.$t=function(...e){return Reflect.apply(n.t,n,[...e])},e.prototype.$d=function(...e){return Reflect.apply(n.d,n,[...e])},e.prototype.$n=function(...e){return Reflect.apply(n.n,n,[...e])},r}registerMessageCompiler(compile),registerMessageResolver(resolveValue),registerLocaleFallbacker(fallbackWithLocaleChain);export{DatetimeFormat,I18nD,I18nInjectionKey,I18nN,I18nT,NumberFormat,Translation,VERSION,castToVueI18n,createI18n,useI18n};
